/***************************************************************
 *
 *	Copyright (C) 1988 by R. L. Biddle
 *	Unversity of Canterbury
 *	Christchurch
 *	New Zealand
 *
 *	Permission is hereby granted to use or redistribute
 *	freely for non-commercial purposes only.
 *
 ***************************************************************/

#include <stdio.h>
#include <strings.h>
#include "args.h"

char argmsg[ARGMSIZE] = "";
char *argusage = argmsg;
unsigned *xargcv;
char ***xargvv;
char ***xargav;

#define	CHARMAX	256
#define	U(c)	((unsigned) (c))
#define SWITCH	((char **) argvv)

unsigned
argscan(argc, argv, swit, flag, pargcv, pargvv, pargav)
unsigned argc, **pargcv;
char **argv, ****pargvv, ****pargav;
char *swit, *flag;
{	char *sw, *fl, **av, *str, *s, *i;
	unsigned ac, u, errors;
	unsigned *argcv; char ***argvv, ***argav;
	extern char *argusage;

	argcv = (unsigned *) calloc(CHARMAX, sizeof(unsigned *));
	argvv = (char ***) calloc(CHARMAX, sizeof(char **));
	argav = (char ***) calloc(CHARMAX, sizeof(char **));

	for (sw = swit; *sw; ++sw) 
		argvv[U(*sw)] = SWITCH;

	fl = flag;
	do { argvv[U(*fl)] = (char **) calloc(argc, sizeof(char *));
	     argav[U(*fl)] = (char **) calloc(argc, sizeof(char *));
	} while (*fl++);

	errors = 0;
	av = argv;
	for (ac = 1; ac < argc; ++ac) {
		str = *++av;
		if ((str[0] == '-') && (u = U(str[1]))) {
			++str;
			if (argvv[u] && (argvv[u] != SWITCH)) {
				s = 0;
				if (*++str) 
					s = str; 
				else   
				if ((ac < (argc-1)) && 
					(((**(av + 1)) != '-') || 
						(!(*(1 + *(av + 1)))))) {
					s = *++av; ++ac; 
				}
				if (s) {
					argvv[u][argcv[u]] = s;
					if (i = index(s, '=')) {
						argav[u][argcv[u]] = ++i;
					}
					++argcv[u];
				}
				else   
					++errors;
			}
			else
				for (s = str; u = U(*s); ++s) {
					++argcv[u];
					if (argvv[u] != SWITCH) 
						++errors;
				}
		}
		else	argvv[0][argcv[0]++] = str;
	}	
	
	fl = flag;
	do { argvv[U(*fl)] = (char **) realloc(argvv[U(*fl)], 
		(argcv[U(*fl)]+1) * sizeof(char **));
	     argav[U(*fl)] = (char **) realloc(argav[U(*fl)], 
		(argcv[U(*fl)]+1) * sizeof(char **));
	} while (*fl++);

	if (errors) {
		if (!*argusage) {
			fprintf(stderr, "Usage: %s", *argv);
			if (*swit) fprintf(stderr, " {-[%s]}", swit);
			if (*flag) fprintf(stderr, " {-[%s] arg}", flag);
			fprintf(stderr, " {arg}\n");
		}
		else	fprintf(stderr, argusage);

		exit(errors);
	}

	(*pargcv) = argcv; (*pargvv) = argvv; (*pargav) = argav;
	return argcv[0];
}
